program barrier_hybride
  use MPI
  use OMP_LIB
  implicit none
  
  integer :: myMPIRank, myOMPRank
  integer :: code, level_mpi_provided
  
  ! Initialisation MPI/OMP
  ! ?
  ! Recuperation myMPIRank
  ! ?
  !$OMP PARALLEL private(myOMPRank)
  myOMPRank = OMP_GET_THREAD_NUM()
  
  ! Desynchronisation des threads
  call desync(myMPIRank,myOMPRank)
  write(*,'(" Avant barriere, processus MPI : ",I3," thread OMP : ",I3)') myMPIRank, myOMPRank
  ! Barriere hybride a coder
  call barrierMPIOMP()
  write(*,'(" Apres barriere, processus MPI : ",I3," thread OMP : ",I3)') myMPIRank, myOMPRank
  
  !$OMP END PARALLEL
  ! Fermeture environnement MPI
  ! ?

  contains

    ! Barriere hybride a coder
    subroutine barrierMPIOMP()
      ! ?
      call sleep(1)
    end subroutine barrierMPIOMP

    ! Desynchronisation des threads, a ne pas toucher
    subroutine desync(myMPIRank,myOMPRank)
      integer, intent(in) :: myMPIRank, myOMPRank
      if (myMPIRank==1 .and. myOMPrank==1) call sleep(10)
    end subroutine desync

end program barrier_hybride
